=== debian/changelog ===
binaryen (96-1) unstable; urgency=medium

  * New upstream version 96.

 -- Markus Koschany <apo@debian.org>  Tue, 18 Aug 2020 01:12:47 +0200

binaryen (95-1) unstable; urgency=medium

  * New upstream version 95.

 -- Markus Koschany <apo@debian.org>  Fri, 24 Jul 2020 01:37:59 +0200

binaryen (94-1) unstable; urgency=medium

  * New upstream version 94.
  * Switch to debhelper-compat = 13.

 -- Markus Koschany <apo@debian.org>  Mon, 15 Jun 2020 22:50:08 +0200

binaryen (93-1) unstable; urgency=medium

  * New upstream version 93.

 -- Markus Koschany <apo@debian.org>  Sun, 03 May 2020 23:07:01 +0200

binaryen (92-1) unstable; urgency=medium

  * New upstream version 92.

 -- Markus Koschany <apo@debian.org>  Mon, 27 Apr 2020 11:17:59 +0200
