=== third_party/CMakeLists.txt ===
if(BUILD_LLVM_DWARF)
  add_subdirectory(llvm-project)
endif()
