=== debian/changelog ===
binaryen (99-3) unstable; urgency=medium

  * Set the correct project version in CMakeLists.txt. (Closes: #981638)

 -- Markus Koschany <apo@debian.org>  Tue, 02 Feb 2021 14:54:30 +0100

binaryen (99-2) unstable; urgency=medium

  * Install missing wasm-delegations.h file.

 -- Markus Koschany <apo@debian.org>  Mon, 11 Jan 2021 23:07:17 +0100

binaryen (99-1) unstable; urgency=medium

  * New upstream version 99.
  * Declare compliance with Debian Policy 4.5.1.

 -- Markus Koschany <apo@debian.org>  Sun, 10 Jan 2021 01:11:59 +0100

binaryen (98-1) unstable; urgency=medium

  * New upstream version 98.

 -- Markus Koschany <apo@debian.org>  Sat, 17 Oct 2020 15:17:51 +0200

binaryen (97-1) unstable; urgency=medium

  * New upstream version 97.

 -- Markus Koschany <apo@debian.org>  Sat, 19 Sep 2020 13:06:35 +0200
