=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  cmake,
  debhelper-compat (= 13),
  python3
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/WebAssembly/binaryen
 Vcs-Git: https://salsa.debian.org/debian/binaryen.git
 Vcs-Browser: https://salsa.debian.org/debian/binaryen
