=== src/ir/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,8 @@
   LocalGraph.cpp
   ReFinalize.cpp
   stack-utils.cpp
+  table-utils.cpp
+  type-updating.cpp
   module-splitting.cpp
   ${ir_HEADERS}
 )
