=== src/ir/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,12 @@
 set(ir_SOURCES
   ExpressionAnalyzer.cpp
   ExpressionManipulator.cpp
+  eh-utils.cpp
+  intrinsics.cpp
+  lubs.cpp
+  memory-utils.cpp
+  names.cpp
+  properties.cpp
   LocalGraph.cpp
   ReFinalize.cpp
   stack-utils.cpp
