=== debian/changelog ===
binaryen (105-1) unstable; urgency=medium

  * New upstream version 105.

 -- Markus Koschany <apo@debian.org>  Sun, 16 Jan 2022 12:52:04 +0100

binaryen (104-1) unstable; urgency=medium

  * New upstream version 104.

 -- Markus Koschany <apo@debian.org>  Tue, 21 Dec 2021 12:36:52 +0100

binaryen (103-1) unstable; urgency=medium

  * New upstream version 103.

 -- Markus Koschany <apo@debian.org>  Sun, 12 Dec 2021 03:04:56 +0100

binaryen (102-1) unstable; urgency=medium

  * New upstream version 102.

 -- Markus Koschany <apo@debian.org>  Tue, 14 Sep 2021 00:21:00 +0200

binaryen (101-1) unstable; urgency=medium

  * New upstream version 101.
  * Declare compliance with Debian Policy 4.6.0.

 -- Markus Koschany <apo@debian.org>  Wed, 18 Aug 2021 20:41:28 +0200

binaryen (100-1) experimental; urgency=medium

  * New upstream version 100.
  * Drop all patches. Fixed upstream.

 -- Markus Koschany <apo@debian.org>  Tue, 09 Mar 2021 23:53:29 +0100
